Log conflicts separately
[stgit] / t / test-lib.sh
CommitLineData
aa9b1b9d
YD
1#!/bin/sh
2#
3# Copyright (c) 2005 Junio C Hamano
4# Copyright (c) 2006 Yann Dirson - tuning for stgit
5#
6
009a6a15
KH
7# Keep the original TERM for say_color
8ORIGINAL_TERM=$TERM
9
aa9b1b9d
YD
10# For repeatability, reset the environment to known value.
11LANG=C
12LC_ALL=C
13PAGER=cat
14TZ=UTC
009a6a15
KH
15TERM=dumb
16export LANG LC_ALL PAGER TERM TZ
48eaeebe
YD
17EDITOR=:
18VISUAL=:
009a6a15 19unset GIT_EDITOR
aa9b1b9d
YD
20unset AUTHOR_DATE
21unset AUTHOR_EMAIL
22unset AUTHOR_NAME
23unset COMMIT_AUTHOR_EMAIL
24unset COMMIT_AUTHOR_NAME
48eaeebe 25unset EMAIL
aa9b1b9d
YD
26unset GIT_ALTERNATE_OBJECT_DIRECTORIES
27unset GIT_AUTHOR_DATE
721ecd12
KH
28GIT_AUTHOR_EMAIL=author@example.com
29GIT_AUTHOR_NAME='A U Thor'
aa9b1b9d 30unset GIT_COMMITTER_DATE
721ecd12
KH
31GIT_COMMITTER_EMAIL=committer@example.com
32GIT_COMMITTER_NAME='C O Mitter'
aa9b1b9d
YD
33unset GIT_DIFF_OPTS
34unset GIT_DIR
009a6a15 35unset GIT_WORK_TREE
aa9b1b9d
YD
36unset GIT_EXTERNAL_DIFF
37unset GIT_INDEX_FILE
38unset GIT_OBJECT_DIRECTORY
39unset SHA1_FILE_DIRECTORIES
40unset SHA1_FILE_DIRECTORY
48eaeebe
YD
41GIT_MERGE_VERBOSITY=5
42export GIT_MERGE_VERBOSITY
aa9b1b9d
YD
43export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
44export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
48eaeebe 45export EDITOR VISUAL
009a6a15 46GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
48eaeebe
YD
47
48# Protect ourselves from common misconfiguration to export
49# CDPATH into the environment
50unset CDPATH
51
52case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
53 1|2|true)
54 echo "* warning: Some tests will not work if GIT_TRACE" \
55 "is set as to trace on STDERR ! *"
56 echo "* warning: Please set GIT_TRACE to something" \
57 "other than 1, 2 or true ! *"
58 ;;
59esac
aa9b1b9d
YD
60
61# Each test should start with something like this, after copyright notices:
62#
63# test_description='Description of this test...
64# This test checks if command xyzzy does the right thing...
65# '
66# . ./test-lib.sh
009a6a15
KH
67[ "x$ORIGINAL_TERM" != "xdumb" ] && (
68 TERM=$ORIGINAL_TERM &&
69 export TERM &&
70 [ -t 1 ] &&
71 tput bold >/dev/null 2>&1 &&
72 tput setaf 1 >/dev/null 2>&1 &&
73 tput sgr0 >/dev/null 2>&1
74 ) &&
75 color=t
aa9b1b9d
YD
76
77while test "$#" -ne 0
78do
79 case "$1" in
80 -d|--d|--de|--deb|--debu|--debug)
81 debug=t; shift ;;
82 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
83 immediate=t; shift ;;
84 -h|--h|--he|--hel|--help)
009a6a15 85 help=t; shift ;;
aa9b1b9d 86 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
b2017c38 87 export STGIT_DEBUG_LEVEL="-1"
aa9b1b9d 88 verbose=t; shift ;;
009a6a15
KH
89 -q|--q|--qu|--qui|--quie|--quiet)
90 quiet=t; shift ;;
91 --no-color)
92 color=; shift ;;
aa9b1b9d
YD
93 *)
94 break ;;
95 esac
96done
97
009a6a15
KH
98if test -n "$color"; then
99 say_color () {
100 (
101 TERM=$ORIGINAL_TERM
102 export TERM
103 case "$1" in
104 error) tput bold; tput setaf 1;; # bold red
105 skip) tput bold; tput setaf 2;; # bold green
106 pass) tput setaf 2;; # green
107 info) tput setaf 3;; # brown
108 *) test -n "$quiet" && return;;
109 esac
110 shift
111 echo "* $*"
112 tput sgr0
113 )
114 }
115else
116 say_color() {
117 test -z "$1" && test -n "$quiet" && return
118 shift
119 echo "* $*"
120 }
121fi
122
123error () {
124 say_color error "error: $*"
125 trap - exit
126 exit 1
127}
128
129say () {
130 say_color info "$*"
131}
132
133test "${test_description}" != "" ||
134error "Test script did not set test_description."
135
136if test "$help" = "t"
137then
138 echo "$test_description"
139 exit 0
140fi
141
aa9b1b9d
YD
142exec 5>&1
143if test "$verbose" = "t"
144then
145 exec 4>&2 3>&1
146else
147 exec 4>/dev/null 3>/dev/null
148fi
149
150test_failure=0
151test_count=0
009a6a15
KH
152test_fixed=0
153test_broken=0
154
155die () {
156 echo >&5 "FATAL: Unexpected exit with code $?"
157 exit 1
158}
aa9b1b9d 159
009a6a15 160trap 'die' exit
aa9b1b9d 161
48eaeebe
YD
162test_tick () {
163 if test -z "${test_tick+set}"
164 then
165 test_tick=1112911993
166 else
167 test_tick=$(($test_tick + 60))
168 fi
169 GIT_COMMITTER_DATE="$test_tick -0700"
170 GIT_AUTHOR_DATE="$test_tick -0700"
171 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
172}
aa9b1b9d
YD
173
174# You are not expected to call test_ok_ and test_failure_ directly, use
175# the text_expect_* functions instead.
176
177test_ok_ () {
178 test_count=$(expr "$test_count" + 1)
009a6a15 179 say_color "" " ok $test_count: $@"
aa9b1b9d
YD
180}
181
182test_failure_ () {
183 test_count=$(expr "$test_count" + 1)
184 test_failure=$(expr "$test_failure" + 1);
009a6a15 185 say_color error "FAIL $test_count: $1"
aa9b1b9d
YD
186 shift
187 echo "$@" | sed -e 's/^/ /'
188 test "$immediate" = "" || { trap - exit; exit 1; }
189}
190
009a6a15
KH
191test_known_broken_ok_ () {
192 test_count=$(expr "$test_count" + 1)
193 test_fixed=$(($test_fixed+1))
194 say_color "" " FIXED $test_count: $@"
195}
196
197test_known_broken_failure_ () {
198 test_count=$(expr "$test_count" + 1)
199 test_broken=$(($test_broken+1))
200 say_color skip " still broken $test_count: $@"
201}
aa9b1b9d
YD
202
203test_debug () {
204 test "$debug" = "" || eval "$1"
205}
206
207test_run_ () {
208 eval >&3 2>&4 "$1"
209 eval_ret="$?"
210 return 0
211}
212
48eaeebe
YD
213test_skip () {
214 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
215 this_test="$this_test.$(expr "$test_count" + 1)"
216 to_skip=
217 for skp in $GIT_SKIP_TESTS
218 do
219 case "$this_test" in
220 $skp)
221 to_skip=t
222 esac
223 done
224 case "$to_skip" in
225 t)
009a6a15 226 say_color skip >&3 "skipping test: $@"
48eaeebe 227 test_count=$(expr "$test_count" + 1)
009a6a15 228 say_color skip "skip $test_count: $1"
48eaeebe
YD
229 : true
230 ;;
231 *)
232 false
233 ;;
234 esac
235}
236
aa9b1b9d
YD
237test_expect_failure () {
238 test "$#" = 2 ||
239 error "bug in the test script: not 2 parameters to test-expect-failure"
48eaeebe 240 if ! test_skip "$@"
aa9b1b9d 241 then
009a6a15 242 say >&3 "checking known breakage: $2"
48eaeebe 243 test_run_ "$2"
009a6a15 244 if [ "$?" = 0 -a "$eval_ret" = 0 ]
48eaeebe 245 then
009a6a15 246 test_known_broken_ok_ "$1"
48eaeebe 247 else
009a6a15 248 test_known_broken_failure_ "$1"
48eaeebe 249 fi
aa9b1b9d 250 fi
48eaeebe 251 echo >&3 ""
aa9b1b9d
YD
252}
253
254test_expect_success () {
255 test "$#" = 2 ||
256 error "bug in the test script: not 2 parameters to test-expect-success"
48eaeebe 257 if ! test_skip "$@"
aa9b1b9d 258 then
48eaeebe
YD
259 say >&3 "expecting success: $2"
260 test_run_ "$2"
261 if [ "$?" = 0 -a "$eval_ret" = 0 ]
262 then
263 test_ok_ "$1"
264 else
265 test_failure_ "$@"
266 fi
aa9b1b9d 267 fi
48eaeebe 268 echo >&3 ""
aa9b1b9d
YD
269}
270
271test_expect_code () {
272 test "$#" = 3 ||
273 error "bug in the test script: not 3 parameters to test-expect-code"
48eaeebe 274 if ! test_skip "$@"
aa9b1b9d 275 then
48eaeebe
YD
276 say >&3 "expecting exit code $1: $3"
277 test_run_ "$3"
278 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
279 then
280 test_ok_ "$2"
281 else
282 test_failure_ "$@"
283 fi
aa9b1b9d 284 fi
48eaeebe 285 echo >&3 ""
aa9b1b9d
YD
286}
287
f03004e2
KH
288# When running an StGit command that should exit with an error, use
289# these instead of testing for any non-zero exit code with !.
290exit_code () {
291 expected=$1
292 shift
293 "$@"
294 test $? -eq $expected
295}
296general_error () { exit_code 1 "$@" ; }
297command_error () { exit_code 2 "$@" ; }
298conflict () { exit_code 3 "$@" ; }
299
300# Old-infrastructure commands don't exit with the proper value on
301# conflicts. But we don't want half the tests to fail because of that,
302# so use this instead of "conflict" for them.
303conflict_old () { command_error "$@" ; }
304
305# Same thing, but for other commands that StGit where we just want to
306# make sure that they fail instead of crashing.
307must_fail () {
308 "$@"
309 test $? -gt 0 -a $? -le 129
310}
311
009a6a15
KH
312# test_cmp is a helper function to compare actual and expected output.
313# You can use it like:
314#
315# test_expect_success 'foo works' '
316# echo expected >expected &&
317# foo >actual &&
318# test_cmp expected actual
319# '
320#
321# This could be written as either "cmp" or "diff -u", but:
322# - cmp's output is not nearly as easy to read as diff -u
323# - not all diff versions understand "-u"
324
325test_cmp() {
326 $GIT_TEST_CMP "$@"
327}
328
329# Most tests can use the created repository, but some may need to create more.
aa9b1b9d
YD
330# Usage: test_create_repo <directory>
331test_create_repo () {
332 test "$#" = 1 ||
333 error "bug in the test script: not 1 parameter to test-create-repo"
3fa9eb26 334 owd=$(pwd)
aa9b1b9d
YD
335 repo="$1"
336 mkdir "$repo"
337 cd "$repo" || error "Cannot setup test environment"
009a6a15
KH
338 git init >/dev/null 2>&1 || error "cannot run git init"
339 echo "empty start" | \
3fa9eb26 340 git commit-tree $(git write-tree) >.git/refs/heads/master 2>&4 || \
009a6a15
KH
341 error "cannot run git commit"
342 mv .git/hooks .git/hooks-disabled
aa9b1b9d
YD
343 cd "$owd"
344}
345
346test_done () {
347 trap - exit
009a6a15
KH
348
349 if test "$test_fixed" != 0
350 then
351 say_color pass "fixed $test_fixed known breakage(s)"
352 fi
353 if test "$test_broken" != 0
354 then
355 say_color error "still have $test_broken known breakage(s)"
356 msg="remaining $(($test_count-$test_broken)) test(s)"
357 else
358 msg="$test_count test(s)"
359 fi
aa9b1b9d
YD
360 case "$test_failure" in
361 0)
362 # We could:
363 # cd .. && rm -fr trash
364 # but that means we forbid any tests that use their own
365 # subdirectory from calling test_done without coming back
366 # to where they started from.
367 # The Makefile provided will clean this test area so
368 # we will leave things as they are.
369
009a6a15 370 say_color pass "passed all $msg"
aa9b1b9d
YD
371 exit 0 ;;
372
373 *)
009a6a15 374 say_color error "failed $test_failure among $msg"
aa9b1b9d
YD
375 exit 1 ;;
376
377 esac
378}
379
380# Test the binaries we have just built. The tests are kept in
381# t/ subdirectory and are run in trash subdirectory.
382PATH=$(pwd)/..:$PATH
29d9e8ce 383HOME=$(pwd)/trash
48eaeebe 384GIT_CONFIG=.git/config
009a6a15 385export PATH HOME GIT_CONFIG
aa9b1b9d
YD
386
387# Test repository
388test=trash
009a6a15
KH
389rm -fr "$test" || {
390 trap - exit
391 echo >&5 "FATAL: Cannot prepare test area"
392 exit 1
393}
394
aa9b1b9d
YD
395test_create_repo $test
396cd "$test"
48eaeebe
YD
397
398this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
399for skp in $GIT_SKIP_TESTS
400do
401 to_skip=
402 for skp in $GIT_SKIP_TESTS
403 do
404 case "$this_test" in
405 $skp)
406 to_skip=t
407 esac
408 done
409 case "$to_skip" in
410 t)
009a6a15
KH
411 say_color skip >&3 "skipping test $this_test altogether"
412 say_color skip "skip all tests in $this_test"
48eaeebe
YD
413 test_done
414 esac
415done